-- FORMATS: wav, aif, mp3, au

property pSM
property pChan

on new me, soundMem, chan
  if voidP(soundMem) then soundMem=new(#sound)
  if voidP(chan) then chan=1
  pSM = soundMem
  pChan = chan
  return me
end

on open (me, nil, fn)
  pSM.filename = fn
  pSM.loop = 1
  sound(pChan).queue(pSM)
end

on play (me)
  sound(pChan).play() --pSM
end

on pause (me)
  sound(pChan).pause()
end

on toggle (me)
  if sound(pChan).status=3 then
    sound(pChan).pause()
  else
    sound(pChan).play()
  end if
end

on stop (me)
  sound(pChan).stop()
end

on setVolume (me, nil, val) -- 0..255
  sound(pChan).volume = val
end

-- ???
on setPosition (me, nil, ms)
  sound(pChan).stop()
  sound(pChan).play([#member:pSM, #startTime:ms])
end

----------------------------------------
-- Info
----------------------------------------
on getDuration me
  return pSM.duration -- ms
end

on getPosition me
  return sound(pChan).elapsedTime -- ms
end

on getPercentPlayed me
  return min(100, me.getPosition()/me.getDuration())
end

on getStatus me
  --return sound(pChan).status -- 0..4
  return [#other,#other,#other,#playing,#paused][sound(pChan).status+1]
end

